/*
 * Copyright (C) 2006 TopCoder Inc., All Rights Reserved.
 */
package com.topcoder.testframework;

import org.apache.tools.ant.Project;

import junit.framework.Test;
import junit.framework.TestCase;
import junit.framework.TestSuite;

/**
 * <p>
 * Component demonstration for Testing Framework Component.
 * </p>
 *
 * <p>
 * This component provides the support for Tomcat web server using Cactus framework as a back-end.
 * It also tries to support other types of servers that Cactus supports.
 * </p>
 *
 * <p>
 * This component is intended to be used as a testing framework integrated with ant. So in this demonstration,
 * Several test cases based on this testing framework component are provided and located in
 * com.topcoder.testframework.demo package and the demo build.xml file is located in test_files directory.
 * </p>
 *
 * <p>
 * This demonstration runs the sample test cases based on the Testing Framework Component using Ant API.
 * (In normal usage, it should be run as <b>ant -demo</b> using a command prompt or any IDE that integrates Ant.)
 * The log file is located in <b>test_files/log</b> directory.
 * </p>
 *
 * <p>
 * Note, a DataServer implementation using HSQL is provided as a demonstration too.
 * </p>
 *
 * @author TCSDEVELOPER
 * @version 1.0
 */
public class Demo extends TestCase {
    /**
     * <p>
     * Setup test environment.
     * </p>
     *
     * @throws Exception to JUnit.
     */
    protected void setUp() throws Exception {
    }

    /**
     * <p>
     * Tears down test environment.
     * </p>
     *
     */
    protected void tearDown() {
        TestHelper.clearTempFiles();
    }

    /**
     * <p>
     * Return all tests.
     * </p>
     *
     * @return all tests
     */
    public static Test suite() {
        return new TestSuite(Demo.class);
    }

    /**
     * <p>
     * Runs the sample test cases based on this Testing Framework Component using Ant API.
     * (In normal usage, it should be run as <b>ant -demo</b> in a command prompt or any IDE that integrates Ant.)
     * The log file is located in test_files/log directory.
     * </p>
     *
     * @throws Exception to JUnit
     */
    public void testTestingFrameworkDemo() throws Exception {
        Project project = TestHelper.getProject("test_files/demo_build.xml");
        project.executeTarget("demo");
    }
}
